'use strict';

exports.__esModule = true;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _path = require('path');

var path = _interopRequireWildcard(_path);

var _arrayIncludes = require('array-includes');

var _arrayIncludes2 = _interopRequireDefault(_arrayIncludes);

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

var _Package = require('./Package');

var _Package2 = _interopRequireDefault(_Package);

var _Workspace = require('./Workspace');

var _Workspace2 = _interopRequireDefault(_Workspace);

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _fs = require('./utils/fs');

var fs = _interopRequireWildcard(_fs);

var _logger = require('./utils/logger');

var logger = _interopRequireWildcard(_logger);

var _messages = require('./utils/messages');

var messages = _interopRequireWildcard(_messages);

var _errors = require('./utils/errors');

var _globs = require('./utils/globs');

var globs = _interopRequireWildcard(_globs);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Project = function () {
  function Project(pkg) {
    (0, _classCallCheck3.default)(this, Project);

    this.pkg = pkg;
  }

  Project.init = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(cwd) {
      var filePath, pkg;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _Config2.default.getProjectConfig(cwd);

            case 2:
              filePath = _context.sent;

              if (filePath) {
                _context.next = 5;
                break;
              }

              throw new _errors.BoltError(`Unable to find root of project in ${cwd}`);

            case 5:
              _context.next = 7;
              return _Package2.default.init(filePath);

            case 7:
              pkg = _context.sent;
              return _context.abrupt('return', new Project(pkg));

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function init(_x) {
      return _ref.apply(this, arguments);
    }

    return init;
  }();

  Project.prototype.getWorkspaces = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
      var queue, workspaces, _iterator, _isArray, _i, _ref3, _pkg, cwd, patterns, matchedPaths, _iterator2, _isArray2, _i2, _ref4, matchedPath, dir, stats, filePath, wPkg, _workspace;

      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              queue = [this.pkg];
              workspaces = [];
              _iterator = queue, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);

            case 3:
              if (!_isArray) {
                _context2.next = 9;
                break;
              }

              if (!(_i >= _iterator.length)) {
                _context2.next = 6;
                break;
              }

              return _context2.abrupt('break', 50);

            case 6:
              _ref3 = _iterator[_i++];
              _context2.next = 13;
              break;

            case 9:
              _i = _iterator.next();

              if (!_i.done) {
                _context2.next = 12;
                break;
              }

              return _context2.abrupt('break', 50);

            case 12:
              _ref3 = _i.value;

            case 13:
              _pkg = _ref3;
              cwd = path.dirname(_pkg.filePath);
              patterns = _pkg.getWorkspacesConfig();
              _context2.next = 18;
              return globs.findWorkspaces(cwd, patterns);

            case 18:
              matchedPaths = _context2.sent;
              _iterator2 = matchedPaths, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : (0, _getIterator3.default)(_iterator2);

            case 20:
              if (!_isArray2) {
                _context2.next = 26;
                break;
              }

              if (!(_i2 >= _iterator2.length)) {
                _context2.next = 23;
                break;
              }

              return _context2.abrupt('break', 48);

            case 23:
              _ref4 = _iterator2[_i2++];
              _context2.next = 30;
              break;

            case 26:
              _i2 = _iterator2.next();

              if (!_i2.done) {
                _context2.next = 29;
                break;
              }

              return _context2.abrupt('break', 48);

            case 29:
              _ref4 = _i2.value;

            case 30:
              matchedPath = _ref4;
              dir = path.join(cwd, matchedPath);
              _context2.next = 34;
              return fs.stat(dir);

            case 34:
              stats = _context2.sent;

              if (stats.isDirectory()) {
                _context2.next = 37;
                break;
              }

              return _context2.abrupt('continue', 46);

            case 37:
              filePath = path.join(dir, 'package.json');
              _context2.next = 40;
              return _Package2.default.init(filePath);

            case 40:
              wPkg = _context2.sent;
              _context2.next = 43;
              return _Workspace2.default.init(wPkg);

            case 43:
              _workspace = _context2.sent;


              queue.push(wPkg);
              workspaces.push(_workspace);

            case 46:
              _context2.next = 20;
              break;

            case 48:
              _context2.next = 3;
              break;

            case 50:
              return _context2.abrupt('return', workspaces);

            case 51:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function getWorkspaces() {
      return _ref2.apply(this, arguments);
    }

    return getWorkspaces;
  }();

  Project.prototype.getDependencyGraph = function () {
    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(workspaces) {
      var graph, packages, packagesByName, valid, _iterator3, _isArray3, _i3, _ref6, _workspace2, _iterator4, _isArray4, _i4, _ref7, _pkg2, name, _dependencies, allDependencies, _iterator5, _isArray5, _i5, _ref9, _ref8, depName, depVersion, match, actual, expected;

      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              graph = new _map2.default();
              packages = [this.pkg];
              packagesByName = { [this.pkg.config.getName()]: this.pkg };
              valid = true;
              _iterator3 = workspaces, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : (0, _getIterator3.default)(_iterator3);

            case 5:
              if (!_isArray3) {
                _context3.next = 11;
                break;
              }

              if (!(_i3 >= _iterator3.length)) {
                _context3.next = 8;
                break;
              }

              return _context3.abrupt('break', 20);

            case 8:
              _ref6 = _iterator3[_i3++];
              _context3.next = 15;
              break;

            case 11:
              _i3 = _iterator3.next();

              if (!_i3.done) {
                _context3.next = 14;
                break;
              }

              return _context3.abrupt('break', 20);

            case 14:
              _ref6 = _i3.value;

            case 15:
              _workspace2 = _ref6;

              packages.push(_workspace2.pkg);
              packagesByName[_workspace2.pkg.config.getName()] = _workspace2.pkg;

            case 18:
              _context3.next = 5;
              break;

            case 20:
              _iterator4 = packages, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : (0, _getIterator3.default)(_iterator4);

            case 21:
              if (!_isArray4) {
                _context3.next = 27;
                break;
              }

              if (!(_i4 >= _iterator4.length)) {
                _context3.next = 24;
                break;
              }

              return _context3.abrupt('break', 64);

            case 24:
              _ref7 = _iterator4[_i4++];
              _context3.next = 31;
              break;

            case 27:
              _i4 = _iterator4.next();

              if (!_i4.done) {
                _context3.next = 30;
                break;
              }

              return _context3.abrupt('break', 64);

            case 30:
              _ref7 = _i4.value;

            case 31:
              _pkg2 = _ref7;
              name = _pkg2.config.getName();
              _dependencies = [];
              allDependencies = _pkg2.getAllDependencies();
              _iterator5 = allDependencies, _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : (0, _getIterator3.default)(_iterator5);

            case 36:
              if (!_isArray5) {
                _context3.next = 42;
                break;
              }

              if (!(_i5 >= _iterator5.length)) {
                _context3.next = 39;
                break;
              }

              return _context3.abrupt('break', 61);

            case 39:
              _ref9 = _iterator5[_i5++];
              _context3.next = 46;
              break;

            case 42:
              _i5 = _iterator5.next();

              if (!_i5.done) {
                _context3.next = 45;
                break;
              }

              return _context3.abrupt('break', 61);

            case 45:
              _ref9 = _i5.value;

            case 46:
              _ref8 = _ref9;
              depName = _ref8[0];
              depVersion = _ref8[1];
              match = packagesByName[depName];

              if (match) {
                _context3.next = 52;
                break;
              }

              return _context3.abrupt('continue', 59);

            case 52:
              actual = depVersion;
              expected = match.config.getVersion();

              // Workspace dependencies only need to semver satisfy, not '==='

              if (_semver2.default.satisfies(expected, depVersion)) {
                _context3.next = 58;
                break;
              }

              valid = false;
              logger.error(messages.packageMustDependOnCurrentVersion(name, depName, expected, depVersion));
              return _context3.abrupt('continue', 59);

            case 58:

              _dependencies.push(depName);

            case 59:
              _context3.next = 36;
              break;

            case 61:

              graph.set(name, { pkg: _pkg2, dependencies: _dependencies });

            case 62:
              _context3.next = 21;
              break;

            case 64:
              return _context3.abrupt('return', { graph, valid });

            case 65:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function getDependencyGraph(_x2) {
      return _ref5.apply(this, arguments);
    }

    return getDependencyGraph;
  }();

  Project.prototype.getDependentsGraph = function () {
    var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(workspaces) {
      var graph, _ref11, valid, dependencyGraph, dependentsLookup;

      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              graph = new _map2.default();
              _context4.next = 3;
              return this.getDependencyGraph(workspaces);

            case 3:
              _ref11 = _context4.sent;
              valid = _ref11.valid;
              dependencyGraph = _ref11.graph;
              dependentsLookup = {};


              workspaces.forEach(function (workspace) {
                dependentsLookup[workspace.pkg.config.getName()] = {
                  pkg: workspace.pkg,
                  dependents: []
                };
              });

              workspaces.forEach(function (workspace) {
                var dependent = workspace.pkg.config.getName();
                var valFromDependencyGraph = dependencyGraph.get(dependent) || {};
                var dependencies = valFromDependencyGraph.dependencies || [];

                dependencies.forEach(function (dependency) {
                  dependentsLookup[dependency].dependents.push(dependent);
                });
              });

              // can't use Object.entries here as the flow type for it is Array<[string, mixed]>;
              (0, _keys2.default)(dependentsLookup).forEach(function (key) {
                graph.set(key, dependentsLookup[key]);
              });

              return _context4.abrupt('return', { valid, graph });

            case 11:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function getDependentsGraph(_x3) {
      return _ref10.apply(this, arguments);
    }

    return getDependentsGraph;
  }();

  // TODO: Properly sort packages using a topological sort, resolving cycles
  // with groups specified in `package.json#pworkspaces`


  Project.runWorkspaceTasks = function () {
    var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(workspaces, task) {
      var promises, _iterator6, _isArray6, _i6, _ref13, _workspace3;

      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              promises = [];
              _iterator6 = workspaces, _isArray6 = Array.isArray(_iterator6), _i6 = 0, _iterator6 = _isArray6 ? _iterator6 : (0, _getIterator3.default)(_iterator6);

            case 2:
              if (!_isArray6) {
                _context5.next = 8;
                break;
              }

              if (!(_i6 >= _iterator6.length)) {
                _context5.next = 5;
                break;
              }

              return _context5.abrupt('break', 16);

            case 5:
              _ref13 = _iterator6[_i6++];
              _context5.next = 12;
              break;

            case 8:
              _i6 = _iterator6.next();

              if (!_i6.done) {
                _context5.next = 11;
                break;
              }

              return _context5.abrupt('break', 16);

            case 11:
              _ref13 = _i6.value;

            case 12:
              _workspace3 = _ref13;

              promises.push(task(_workspace3));

            case 14:
              _context5.next = 2;
              break;

            case 16:
              _context5.next = 18;
              return _promise2.default.all(promises);

            case 18:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function runWorkspaceTasks(_x4, _x5) {
      return _ref12.apply(this, arguments);
    }

    return runWorkspaceTasks;
  }();

  Project.prototype.getWorkspaceByName = function getWorkspaceByName(workspaces, workspaceName) {
    return workspaces.find(function (workspace) {
      return workspace.pkg.config.getName() === workspaceName;
    });
  };

  Project.prototype.filterWorkspaces = function filterWorkspaces(workspaces, opts) {
    var _this = this;

    var relativeDir = function relativeDir(workspace) {
      return path.relative(_this.pkg.dir, workspace.pkg.dir);
    };

    var workspaceNames = workspaces.map(function (ws) {
      return ws.pkg.config.getName();
    });
    var workspaceDirs = workspaces.map(function (ws) {
      return relativeDir(ws);
    });

    var filteredByName = globs.matchOnlyAndIgnore(workspaceNames, opts.only, opts.ignore);

    var filteredByDir = globs.matchOnlyAndIgnore(workspaceDirs, opts.onlyFs, opts.ignoreFs);

    var filteredWorkspaces = workspaces.filter(function (workspace) {
      return (0, _arrayIncludes2.default)(filteredByName, workspace.pkg.config.getName()) && (0, _arrayIncludes2.default)(filteredByDir, relativeDir(workspace));
    });

    if (filteredWorkspaces.length === 0) {
      logger.warn(messages.noPackagesMatchFilters());
    }

    return filteredWorkspaces;
  };

  return Project;
}();

exports.default = Project;