'use strict';

exports.__esModule = true;
exports.projectRun = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var projectRun = exports.projectRun = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(opts) {
    var cwd, project, validScript;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            cwd = opts.cwd || process.cwd();
            _context.next = 3;
            return _Project2.default.init(cwd);

          case 3:
            project = _context.sent;
            _context.next = 6;
            return yarn.run(project.pkg, opts.script, opts.scriptArgs);

          case 6:
            validScript = _context.sent;

            if (validScript) {
              _context.next = 9;
              break;
            }

            throw new _errors.BoltError(`Package at "${project.pkg.dir}" does not have a script named "${opts.script}"`);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function projectRun(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.toProjectRunOptions = toProjectRunOptions;

var _Project = require('../../Project');

var _Project2 = _interopRequireDefault(_Project);

var _options = require('../../utils/options');

var options = _interopRequireWildcard(_options);

var _yarn = require('../../utils/yarn');

var yarn = _interopRequireWildcard(_yarn);

var _errors = require('../../utils/errors');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toProjectRunOptions(args, flags) {
  var script = args[0],
      scriptArgs = args.slice(1);

  return {
    cwd: options.string(flags.cwd, 'cwd'),
    script,
    scriptArgs
  };
}