'use strict';

exports.__esModule = true;
exports.publish = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getUnpublishedPackages = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(packages) {
    var _this = this;

    var results;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _promise2.default.all(packages.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(pkg) {
                var config, response;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        config = pkg.config;
                        _context.next = 3;
                        return npm.infoAllow404(config.getName());

                      case 3:
                        response = _context.sent;
                        return _context.abrupt('return', {
                          name: config.getName(),
                          localVersion: config.getVersion(),
                          isPublished: response.published,
                          publishedVersion: response.pkgInfo.version || ''
                        });

                      case 5:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 2:
            results = _context2.sent;
            return _context2.abrupt('return', results.filter(function (result) {
              // only publish if our version is higher than the one on npm
              return !result.isPublished || _semver2.default.gt(result.localVersion, result.publishedVersion);
            }));

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getUnpublishedPackages(_x) {
    return _ref.apply(this, arguments);
  };
}();

var publish = exports.publish = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(opts) {
    var _this2 = this;

    var cwd, project, workspaces, packages, unpublishedPackages, isUnpublished, unpublishedWorkspaces;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            cwd = opts.cwd || process.cwd();
            _context4.next = 3;
            return _Project2.default.init(cwd);

          case 3:
            project = _context4.sent;
            _context4.next = 6;
            return project.getWorkspaces();

          case 6:
            workspaces = _context4.sent;
            packages = workspaces.map(function (workspace) {
              return workspace.pkg;
            }).filter(function (pkg) {
              return !pkg.config.getPrivate();
            });
            _context4.prev = 8;
            _context4.next = 11;
            return getUnpublishedPackages(packages);

          case 11:
            unpublishedPackages = _context4.sent;

            isUnpublished = function isUnpublished(workspace) {
              return unpublishedPackages.some(function (pkg) {
                return workspace.pkg.config.getName() === pkg.name;
              });
            };

            unpublishedWorkspaces = workspaces.filter(isUnpublished);


            if (unpublishedPackages.length === 0) {
              logger.warn(messages.noUnpublishedPackagesToPublish());
            }

            _context4.next = 17;
            return _Project2.default.runWorkspaceTasks(unpublishedWorkspaces, function () {
              var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(workspace) {
                var name, version;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        name = workspace.pkg.config.getName();
                        version = workspace.pkg.config.getVersion();

                        logger.info(messages.publishingPackage(name, version));

                        _context3.next = 5;
                        return npm.publish(name, { cwd: workspace.pkg.dir, access: opts.access });

                      case 5:
                      case 'end':
                        return _context3.stop();
                    }
                  }
                }, _callee3, _this2);
              }));

              return function (_x4) {
                return _ref4.apply(this, arguments);
              };
            }());

          case 17:
            _context4.next = 23;
            break;

          case 19:
            _context4.prev = 19;
            _context4.t0 = _context4['catch'](8);

            logger.error(_context4.t0.message);
            throw new _errors.BoltError('Failed to publish');

          case 23:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this, [[8, 19]]);
  }));

  return function publish(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

exports.toPublishOptions = toPublishOptions;

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

var _options = require('../utils/options');

var options = _interopRequireWildcard(_options);

var _errors = require('../utils/errors');

var _logger = require('../utils/logger');

var logger = _interopRequireWildcard(_logger);

var _messages = require('../utils/messages');

var messages = _interopRequireWildcard(_messages);

var _locks = require('../utils/locks');

var locks = _interopRequireWildcard(_locks);

var _npm = require('../utils/npm');

var npm = _interopRequireWildcard(_npm);

var _Project = require('../Project');

var _Project2 = _interopRequireDefault(_Project);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toPublishOptions(args, flags) {
  return {
    cwd: options.string(flags.cwd, 'cwd'),
    access: options.string(flags.access, 'access')
  };
}