'use strict';

exports.__esModule = true;
exports.infoAllow404 = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var infoAllow404 = exports.infoAllow404 = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(pkgName) {
    var pkgInfo, output;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return info(pkgName);

          case 3:
            pkgInfo = _context2.sent;
            return _context2.abrupt('return', { published: true, pkgInfo });

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2['catch'](0);
            output = JSON.parse(_context2.t0.stdout);

            if (!(output.error && output.error.code === 'E404')) {
              _context2.next = 13;
              break;
            }

            logger.warn(messages.npmInfo404(pkgName));
            return _context2.abrupt('return', { published: false, pkgInfo: {} });

          case 13:
            throw _context2.t0;

          case 14:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 7]]);
  }));

  return function infoAllow404(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.info = info;
exports.publish = publish;
exports.addTag = addTag;
exports.removeTag = removeTag;

var _errors = require('./errors');

var _logger = require('./logger');

var logger = _interopRequireWildcard(_logger);

var _messages = require('./messages');

var messages = _interopRequireWildcard(_messages);

var _processes = require('./processes');

var processes = _interopRequireWildcard(_processes);

var _pLimit = require('p-limit');

var _pLimit2 = _interopRequireDefault(_pLimit);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var npmRequestLimit = (0, _pLimit2.default)(40);
function info(pkgName) {
  var _this = this;

  return npmRequestLimit((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            logger.info(messages.npmInfo(pkgName));

            _context.next = 3;
            return processes.spawn('npm', ['info', pkgName, '--json'], {
              silent: true
            });

          case 3:
            result = _context.sent;
            return _context.abrupt('return', JSON.parse(result.stdout));

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, _this);
  })));
}

function publish(pkgName) {
  var _this2 = this;

  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return npmRequestLimit((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    var publishFlags;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            logger.info(messages.npmPublish(pkgName));
            publishFlags = opts.access ? ['--access', opts.access] : [];
            _context3.next = 4;
            return processes.spawn('npm', ['publish'].concat(publishFlags), {
              cwd: opts.cwd
            });

          case 4:
            return _context3.abrupt('return', _context3.sent);

          case 5:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, _this2);
  })));
}

function addTag(pkgName, pkgVersion, tag) {
  var _this3 = this;

  return npmRequestLimit((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
    var pkgStr, result;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            logger.info(messages.npmDistTagAdd(pkgName, pkgVersion, tag));
            pkgStr = `${pkgName}@${pkgVersion}`;
            _context4.next = 4;
            return processes.spawn('npm', ['dist-tag', 'add', pkgStr, tag]);

          case 4:
            result = _context4.sent;

            if (!result.stderr) {
              _context4.next = 7;
              break;
            }

            throw new _errors.BoltError(`Could not add tag ${tag} to ${pkgStr} as one already exists`);

          case 7:
            return _context4.abrupt('return', result);

          case 8:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, _this3);
  })));
}

function removeTag(pkgName, tag) {
  var _this4 = this;

  return npmRequestLimit((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            logger.info(messages.npmDistTagRm(pkgName, tag));

            _context5.prev = 1;
            _context5.next = 4;
            return processes.spawn('npm', ['dist-tag', 'rm', pkgName, tag], {
              silent: true
            });

          case 4:
            return _context5.abrupt('return', _context5.sent);

          case 7:
            _context5.prev = 7;
            _context5.t0 = _context5['catch'](1);

            if (!(_context5.t0.code === 1 && _context5.t0.stderr.includes('is not a dist-tag on'))) {
              _context5.next = 14;
              break;
            }

            logger.warn(messages.notDistTagFound(tag, pkgName));
            return _context5.abrupt('return');

          case 14:
            if (!(_context5.t0.stderr && _context5.t0.stderr.startsWith('npm ERR! code E404'))) {
              _context5.next = 17;
              break;
            }

            // the package does not exist yet, warn but dont error
            logger.warn(messages.npmPackageCouldNotBeFound(pkgName));
            return _context5.abrupt('return');

          case 17:
            throw _context5.t0;

          case 18:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, _this4, [[1, 7]]);
  })));
}