'use strict';

exports.__esModule = true;
exports.remove = exports.init = exports.getScript = exports.runIfExists = exports.run = exports.add = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var add = exports.add = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(pkg, dependencies, type) {
    var spawnArgs, flag;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spawnArgs = ['add'];

            if (dependencies.length) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return');

          case 3:

            dependencies.forEach(function (dep) {
              if (dep.version) {
                spawnArgs.push(`${dep.name}@${dep.version}`);
              } else {
                spawnArgs.push(dep.name);
              }
            });

            if (type) {
              flag = depTypeToFlag(type);

              if (flag) spawnArgs.push(flag);
            }

            _context.next = 7;
            return processes.spawn('yarn', spawnArgs, {
              cwd: pkg.dir,
              pkg: pkg,
              tty: true
            });

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function add(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var run = exports.run = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(pkg, script) {
    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var spawnArgs;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            spawnArgs = ['run', '-s', script];


            if (args.length) {
              spawnArgs = spawnArgs.concat('--', args);
            }

            _context2.next = 4;
            return processes.spawn('yarn', spawnArgs, {
              cwd: pkg.dir,
              pkg: pkg,
              tty: true
            });

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function run(_x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}();

var runIfExists = exports.runIfExists = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(pkg, script) {
    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var scriptExists;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getScript(pkg, script);

          case 2:
            scriptExists = _context3.sent;

            if (!scriptExists) {
              _context3.next = 6;
              break;
            }

            _context3.next = 6;
            return run(pkg, script, args);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function runIfExists(_x8, _x9) {
    return _ref3.apply(this, arguments);
  };
}();

var getScript = exports.getScript = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(pkg, script) {
    var result, scripts, bins;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            result = null;
            scripts = pkg.config.getScripts();


            if (scripts && scripts[script]) {
              result = scripts[script];
            }

            if (result) {
              _context4.next = 8;
              break;
            }

            _context4.next = 6;
            return fs.readdirSafe(pkg.nodeModulesBin);

          case 6:
            bins = _context4.sent;


            if ((0, _arrayIncludes2.default)(bins, script)) {
              result = script;
            }

          case 8:
            return _context4.abrupt('return', result);

          case 9:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function getScript(_x10, _x11) {
    return _ref4.apply(this, arguments);
  };
}();

var init = exports.init = function () {
  var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(cwd) {
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return processes.spawn('yarn', ['init', '-s'], {
              cwd: cwd,
              tty: true
            });

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function init(_x12) {
    return _ref5.apply(this, arguments);
  };
}();

var remove = exports.remove = function () {
  var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(dependencies, cwd) {
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return processes.spawn('yarn', ['remove'].concat(dependencies), {
              cwd,
              tty: true
            });

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function remove(_x13, _x14) {
    return _ref6.apply(this, arguments);
  };
}();

var _arrayIncludes = require('array-includes');

var _arrayIncludes2 = _interopRequireDefault(_arrayIncludes);

var _processes = require('./processes');

var processes = _interopRequireWildcard(_processes);

var _fs = require('../utils/fs');

var fs = _interopRequireWildcard(_fs);

var logger = _interopRequireWildcard(_fs);

var _constants = require('../constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function depTypeToFlag(depType) {
  var flag = (0, _keys2.default)(_constants.DEPENDENCY_TYPE_FLAGS_MAP).find(function (key) {
    return _constants.DEPENDENCY_TYPE_FLAGS_MAP[key] === depType;
  });

  return flag ? `--${flag}` : flag;
}