'use strict';

exports.__esModule = true;
exports.toWorkspacesRunOptions = toWorkspacesRunOptions;
exports.workspacesRun = workspacesRun;

var _options = require('../../utils/options');

var options = _interopRequireWildcard(_options);

var _Project = require('../../Project');

var _Project2 = _interopRequireDefault(_Project);

var _yarn = require('../../utils/yarn');

var yarn = _interopRequireWildcard(_yarn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function toWorkspacesRunOptions(args, flags) {
  let [script, ...scriptArgs] = args;
  return {
    cwd: options.string(flags.cwd, 'cwd'),
    script,
    scriptArgs,
    filterOpts: options.toFilterOpts(flags)
  };
}

async function workspacesRun(opts) {
  let cwd = opts.cwd || process.cwd();
  let project = await _Project2.default.init(cwd);
  let workspaces = await project.getWorkspaces();
  let filteredWorkspaces = project.filterWorkspaces(workspaces, opts.filterOpts);

  await _Project2.default.runWorkspaceTasks(filteredWorkspaces, async workspace => {
    // no need to error if script doesn't exist
    await yarn.runIfExists(workspace.pkg, opts.script, opts.scriptArgs);
  });
}